# HG changeset patch
# Node ID 9a05207c3944acab6f945ab5821c5f45f1d9c6a4
# Parent  9d8be988205cb31fe69b56b50f2c8f37f22d75b0
diff --git a/pidgin/meson.build b/pidgin/meson.build
--- a/pidgin/meson.build
+++ b/pidgin/meson.build
@@ -35,6 +35,7 @@
 	'pidginnotification.c',
 	'pidginnotificationaddcontact.c',
 	'pidginnotificationauthorizationrequest.c',
+	'pidginnotificationconnectionerror.c',
 	'pidginnotificationlink.c',
 	'pidginnotificationlist.c',
 	'pidginpluginsmenu.c',
@@ -84,6 +85,7 @@
 	'pidginnotification.h',
 	'pidginnotificationaddcontact.h',
 	'pidginnotificationauthorizationrequest.h',
+	'pidginnotificationconnectionerror.h',
 	'pidginnotificationlink.h',
 	'pidginnotificationlist.h',
 	'pidginpluginsmenu.h',
diff --git a/pidgin/pidginnotificationconnectionerror.c b/pidgin/pidginnotificationconnectionerror.c
new file mode 100644
--- /dev/null
+++ b/pidgin/pidginnotificationconnectionerror.c
@@ -0,0 +1,101 @@
+/*
+ * Pidgin - Internet Messenger
+ * Copyright (C) Pidgin Developers <devel@pidgin.im>
+ *
+ * Pidgin is the legal property of its developers, whose names are too numerous
+ * to list here.  Please refer to the COPYRIGHT file distributed with this
+ * source distribution.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <https://www.gnu.org/licenses/>.
+ */
+
+#include <glib/gi18n-lib.h>
+
+#include <purple.h>
+
+#include "pidgin/pidginnotificationconnectionerror.h"
+
+struct _PidginNotificationConnectionError {
+	PidginNotification parent;
+
+	GtkWidget *reconnect;
+	GtkWidget *modify;
+};
+
+G_DEFINE_FINAL_TYPE(PidginNotificationConnectionError,
+                    pidgin_notification_connection_error, PIDGIN_TYPE_NOTIFICATION)
+
+/******************************************************************************
+ * GObject Implementation
+ *****************************************************************************/
+static void
+pidgin_notification_connection_error_init(PidginNotificationConnectionError *notification)
+{
+	gtk_widget_init_template(GTK_WIDGET(notification));
+}
+
+static void
+pidgin_notification_connection_error_constructed(GObject *obj) {
+	PurpleAccount *account = NULL;
+	PidginNotification *pidgin_notification = PIDGIN_NOTIFICATION(obj);
+	PidginNotificationConnectionError *error = PIDGIN_NOTIFICATION_CONNECTION_ERROR(obj);
+	PurpleNotification *purple_notification = NULL;
+	const char *id = NULL;
+
+	G_OBJECT_CLASS(pidgin_notification_connection_error_parent_class)->constructed(obj);
+
+	purple_notification = pidgin_notification_get_notification(pidgin_notification);
+	account = purple_notification_get_account(purple_notification);
+	id = purple_account_get_id(account);
+
+	gtk_actionable_set_action_target(GTK_ACTIONABLE(error->reconnect), "s",
+	                                 id);
+	gtk_actionable_set_action_target(GTK_ACTIONABLE(error->modify), "s", id);
+}
+
+static void
+pidgin_notification_connection_error_class_init(PidginNotificationConnectionErrorClass *klass)
+{
+	GObjectClass *obj_class = G_OBJECT_CLASS(klass);
+	GtkWidgetClass *widget_class = GTK_WIDGET_CLASS(klass);
+
+	obj_class->constructed = pidgin_notification_connection_error_constructed;
+
+	gtk_widget_class_set_template_from_resource(
+	    widget_class,
+	    "/im/pidgin/Pidgin3/notificationconnectionerror.ui"
+	);
+
+	gtk_widget_class_bind_template_child(widget_class,
+	                                     PidginNotificationConnectionError,
+	                                     reconnect);
+	gtk_widget_class_bind_template_child(widget_class,
+	                                     PidginNotificationConnectionError,
+	                                     modify);
+}
+
+/******************************************************************************
+ * API
+ *****************************************************************************/
+GtkWidget *
+pidgin_notification_connection_error_new(PurpleNotificationConnectionError *notification)
+{
+	g_return_val_if_fail(PURPLE_IS_NOTIFICATION_CONNECTION_ERROR(notification),
+	                     NULL);
+
+	return g_object_new(
+		PIDGIN_TYPE_NOTIFICATION_CONNECTION_ERROR,
+		"notification", notification,
+		NULL);
+}
diff --git a/pidgin/pidginnotificationconnectionerror.h b/pidgin/pidginnotificationconnectionerror.h
new file mode 100644
--- /dev/null
+++ b/pidgin/pidginnotificationconnectionerror.h
@@ -0,0 +1,76 @@
+/*
+ * Pidgin - Internet Messenger
+ * Copyright (C) Pidgin Developers <devel@pidgin.im>
+ *
+ * Pidgin is the legal property of its developers, whose names are too numerous
+ * to list here.  Please refer to the COPYRIGHT file distributed with this
+ * source distribution.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <https://www.gnu.org/licenses/>.
+ */
+
+#if !defined(PIDGIN_GLOBAL_HEADER_INSIDE) && !defined(PIDGIN_COMPILATION)
+# error "only <pidgin.h> may be included directly"
+#endif
+
+#ifndef PIDGIN_NOTIFICATION_CONNECTION_ERROR_H
+#define PIDGIN_NOTIFICATION_CONNECTION_ERROR_H
+
+#include <glib.h>
+
+#include <gtk/gtk.h>
+
+#include <adwaita.h>
+
+#include <purple.h>
+
+#include "pidginnotification.h"
+#include "pidginversion.h"
+
+G_BEGIN_DECLS
+
+/**
+ * PidginNotificationConnectionError:
+ *
+ * #PidginNotificationConnectionError is a widget that displays
+ * notifications from [class@Purple.NotificationManager] for
+ * connection errors on [class@Purple.Account]'s.
+ *
+ * Since: 3.0
+ */
+
+#define PIDGIN_TYPE_NOTIFICATION_CONNECTION_ERROR (pidgin_notification_connection_error_get_type())
+
+PIDGIN_AVAILABLE_IN_3_0
+G_DECLARE_FINAL_TYPE(PidginNotificationConnectionError,
+                     pidgin_notification_connection_error,
+                     PIDGIN, NOTIFICATION_CONNECTION_ERROR, PidginNotification)
+
+/**
+ * pidgin_notification_connection_error_new:
+ * @notification: The [class@Purple.NotificationConnectionError] instance.
+ *
+ * Creates a new #PidginNotificationConnectionError instance that will display
+ * @notification.
+ *
+ * Returns: (transfer full): The new instance.
+ *
+ * Since: 3.0
+ */
+PIDGIN_AVAILABLE_IN_3_0
+GtkWidget *pidgin_notification_connection_error_new(PurpleNotificationConnectionError *notification);
+
+G_END_DECLS
+
+#endif /* PIDGIN_NOTIFICATION_CONNECTION_ERROR_H */
diff --git a/pidgin/pidginnotificationlist.c b/pidgin/pidginnotificationlist.c
--- a/pidgin/pidginnotificationlist.c
+++ b/pidgin/pidginnotificationlist.c
@@ -30,6 +30,7 @@
 #include "pidginnotification.h"
 #include "pidginnotificationaddcontact.h"
 #include "pidginnotificationauthorizationrequest.h"
+#include "pidginnotificationconnectionerror.h"
 #include "pidginnotificationlink.h"
 
 enum {
@@ -115,6 +116,11 @@
 
 		request = PURPLE_NOTIFICATION_AUTHORIZATION_REQUEST(notification);
 		widget = pidgin_notification_authorization_request_new(request);
+	} else if(PURPLE_IS_NOTIFICATION_CONNECTION_ERROR(notification)) {
+		PurpleNotificationConnectionError *error = NULL;
+
+		error = PURPLE_NOTIFICATION_CONNECTION_ERROR(notification);
+		widget = pidgin_notification_connection_error_new(error);
 	} else if(PURPLE_IS_NOTIFICATION_LINK(notification)) {
 		widget = pidgin_notification_link_new(notification);
 	} else {
diff --git a/pidgin/resources/notificationconnectionerror.ui b/pidgin/resources/notificationconnectionerror.ui
new file mode 100644
--- /dev/null
+++ b/pidgin/resources/notificationconnectionerror.ui
@@ -0,0 +1,58 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!--
+Pidgin - Internet Messenger
+Copyright (C) Pidgin Developers <devel@pidgin.im>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, see <https://www.gnu.org/licenses/>.
+
+-->
+<interface>
+  <requires lib="gtk" version="4.0"/>
+  <!-- interface-license-type gplv2 -->
+  <!-- interface-name Pidgin -->
+  <!-- interface-description Internet Messenger -->
+  <!-- interface-copyright Pidgin Developers <devel@pidgin.im> -->
+  <template class="PidginNotificationConnectionError" parent="PidginNotification">
+    <property name="child">
+      <object class="GtkBox">
+        <property name="orientation">horizontal</property>
+        <property name="spacing">6</property>
+        <property name="valign">start</property>
+        <child>
+          <object class="GtkButton" id="reconnect">
+            <property name="label" translatable="1">Reconnect</property>
+            <property name="focusable">1</property>
+            <property name="receives-default">1</property>
+            <property name="halign">center</property>
+            <property name="valign">center</property>
+            <property name="action-name">app.connect-account</property>
+            <style>
+              <class name="suggested-action"/>
+            </style>
+          </object>
+        </child>
+        <child>
+          <object class="GtkButton" id="modify">
+            <property name="label" translatable="1">Modify</property>
+            <property name="focusable">1</property>
+            <property name="receives-default">1</property>
+            <property name="halign">center</property>
+            <property name="valign">center</property>
+            <property name="action-name">app.edit-account</property>
+          </object>
+        </child>
+      </object>
+    </property>
+  </template>
+</interface>
diff --git a/pidgin/resources/pidgin.gresource.xml b/pidgin/resources/pidgin.gresource.xml
--- a/pidgin/resources/pidgin.gresource.xml
+++ b/pidgin/resources/pidgin.gresource.xml
@@ -38,6 +38,7 @@
     <file compressed="true" preprocess="xml-stripblanks">notification.ui</file>
     <file compressed="true" preprocess="xml-stripblanks">notificationaddcontact.ui</file>
     <file compressed="true" preprocess="xml-stripblanks">notificationauthorizationrequest.ui</file>
+    <file compressed="true" preprocess="xml-stripblanks">notificationconnectionerror.ui</file>
     <file compressed="true" preprocess="xml-stripblanks">notificationlink.ui</file>
     <file compressed="true" preprocess="xml-stripblanks">notificationlist.ui</file>
     <file compressed="true" preprocess="xml-stripblanks">presenceicon.ui</file>
